/** 
 * Types that represent physical units.
 */
// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#pragma once

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif


/**
 * Helper macro which allows to select between two macros depending on the presence of an argument.
 */
#define SELECT_UNIT_MACRO_(ignored1, value, NAME, ...) (NAME(value))

/**
 * Helper macro which allows to select between the constructor for an unit, or the unit type itself
 * depending on the existence of an optional argument.
 *
 * @note This allows C code to treat units as if they were C++ classes with an explicit constructor.
 * @param type The unit that will be returned, if no argument was specified.
 * @param constructor The constructor that will be returned, if an argument was specified.
 * @param ... The optional argument, will be passed to the constructor if given.
 */
#define ADD_UNIT_CONSTRUCTOR(type, constructor, ...) \
    SELECT_UNIT_MACRO_(ignored1, ##__VA_ARGS__, constructor, type)

/**
 * Define a new unit type.
 * These types provide a compile-time unit safety.
 *
 * @param type The datatype that is used to represent the unit.
 * @param unit The name of the unit.
 */
#define UNIT_TYPE(type, unit) \
    typedef struct {          \
        type unit;            \
    } unit##_t

/**
 * Define a variant of an unit type.
 * These types represents the same unit, but has a different underlying data type.
 *
 * @param type The datatype that is used to represent this variant.
 * @param unit The name of the base unit.
 * @param variant The appendix to the name that signifies this variant
 */
#define UNIT_VARIANT_TYPE(type, unit, variant) \
    typedef struct {                           \
        type unit;                             \
    } unit##variant##_t

/**
 * Rotations per minute.
 */
UNIT_TYPE(double, rpm);
#define rpm_t_CONSTRUCTOR(value) ((rpm_t) {value})
#define rpm_t(...) ADD_UNIT_CONSTRUCTOR(rpm_t, rpm_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * Pulse with modulation (in percent from 0 to 100).
 */
UNIT_TYPE(double, pwm);
#define pwm_t_CONSTRUCTOR(value) ((pwm_t) {value})
#define pwm_t(...) ADD_UNIT_CONSTRUCTOR(pwm_t, pwm_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * Voltage.
 */
UNIT_TYPE(double, volt);
#define volt_t_CONSTRUCTOR(value) ((volt_t) {value})
#define volt_t(...) ADD_UNIT_CONSTRUCTOR(volt_t, volt_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * Voltage.
 */
UNIT_VARIANT_TYPE(float, volt, Float);
#define voltFloat_t_CONSTRUCTOR(value) ((voltFloat_t) {value})
#define voltFloat_t(...) ADD_UNIT_CONSTRUCTOR(voltFloat_t, voltFloat_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * Pressure.
 */
UNIT_TYPE(float, bar);
#define bar_t_CONSTRUCTOR(value) ((bar_t) {value})
#define bar_t(...) ADD_UNIT_CONSTRUCTOR(bar_t, bar_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * A distance in meter.
 */
UNIT_TYPE(double, meter);
#define meter_t_CONSTRUCTOR(value) ((meter_t) {value})
#define meter_t(...) ADD_UNIT_CONSTRUCTOR(meter_t, meter_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * An angle in degrees.
 */
UNIT_TYPE(double, deg);
#define deg_t_CONSTRUCTOR(value) ((deg_t) {value})
#define deg_t(...) ADD_UNIT_CONSTRUCTOR(deg_t, deg_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * A time in seconds.
 */
UNIT_TYPE(double, sec);
#define sec_t_CONSTRUCTOR(value) ((sec_t) {value})
#define sec_t(...) ADD_UNIT_CONSTRUCTOR(sec_t, sec_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * A time in milliseconds.
 */
UNIT_TYPE(uint32_t, ms);
#define ms_t_CONSTRUCTOR(value) ((ms_t) {value})
#define ms_t(...) ADD_UNIT_CONSTRUCTOR(ms_t, ms_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * A temperature in °C.
 */
UNIT_TYPE(float, celsius);
#define celsius_t_CONSTRUCTOR(value) ((celsius_t) {value})
#define celsius_t(...) ADD_UNIT_CONSTRUCTOR(celsius_t, celsius_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * A temperature in °C.
 */
UNIT_VARIANT_TYPE(int8_t, celsius, Int8);
#define celsiusInt8_t_CONSTRUCTOR(value) ((celsiusInt8_t) {value})
#define celsiusInt8_t(...) ADD_UNIT_CONSTRUCTOR(celsiusInt8_t, celsiusInt8_t_CONSTRUCTOR, \
    __VA_ARGS__)

/**
 * An acceleration in meters per seconds squared.
 */
UNIT_TYPE(float, mps2);
#define mps2_t_CONSTRUCTOR(value) ((mps2_t) {value})
#define mps2_t(...) ADD_UNIT_CONSTRUCTOR(mps2_t, mps2_t_CONSTRUCTOR, __VA_ARGS__)

/**
 * Magnetic field strength in micro tesla.
 */
UNIT_TYPE(float, microTesla);
#define microTesla_t_CONSTRUCTOR(value) ((microTesla_t) {value})
#define microTesla_t(...) ADD_UNIT_CONSTRUCTOR(microTesla_t, microTesla_t_CONSTRUCTOR, \
    __VA_ARGS__)



#ifdef __cplusplus
}

#define OPERATOR_IMPLEMENTATION(unit, baseType)                                     \
    constexpr unit ## _t operator+(const unit ## _t left, const unit ## _t right) { \
        return unit ## _t(left.unit + right.unit);                                  \
    }                                                                               \
                                                                                    \
    constexpr unit ## _t operator-(const unit ## _t left, const unit ## _t right) { \
        return unit ## _t(left.unit - right.unit);                                  \
    }                                                                               \
                                                                                    \
    constexpr unit ## _t operator-(const unit ## _t left) {                         \
        return unit ## _t(-left.unit);                                              \
    }                                                                               \
                                                                                    \
    constexpr bool operator<(const unit ## _t left, const unit ## _t right) {       \
        return left.unit < right.unit;                                              \
    }                                                                               \
                                                                                    \
    constexpr bool operator<=(const unit ## _t left, const unit ## _t right) {      \
        return left.unit <= right.unit;                                             \
    }                                                                               \
                                                                                    \
    constexpr bool operator>(const unit ## _t left, const unit ## _t right) {       \
        return left.unit > right.unit;                                              \
    }                                                                               \
                                                                                    \
    constexpr bool operator>=(const unit ## _t left, const unit ## _t right) {      \
        return left.unit >= right.unit;                                             \
    }                                                                               \
                                                                                    \
    constexpr bool operator==(const unit ## _t left, const unit ## _t right) {      \
        return left.unit == right.unit;                                             \
    }                                                                               \
                                                                                    \
    constexpr bool operator!=(const unit ## _t left, const unit ## _t right) {      \
        return left.unit != right.unit;                                             \
    }                                                                               \
                                                                                    \
    constexpr unit ## _t operator "" _ ## unit(unsigned long long value) {          \
        return unit ## _t(static_cast<baseType>(value));                            \
    }                                                                                \


OPERATOR_IMPLEMENTATION(rpm, double)
OPERATOR_IMPLEMENTATION(pwm, double)
OPERATOR_IMPLEMENTATION(volt, double)
OPERATOR_IMPLEMENTATION(bar, float)
OPERATOR_IMPLEMENTATION(meter, double)
OPERATOR_IMPLEMENTATION(deg, double)
OPERATOR_IMPLEMENTATION(sec, double)
OPERATOR_IMPLEMENTATION(ms, uint32_t)
OPERATOR_IMPLEMENTATION(celsius, float)
OPERATOR_IMPLEMENTATION(mps2, float)
OPERATOR_IMPLEMENTATION(microTesla, float)

#endif /* __cplusplus */
